models/Tripulantes.php
<?php

namespace app\models;


use Yii;
use yii\db\ActiveRecord;

/**
 * This is the model class for table "tripulantes".
 *
 * @property string $n_jugador
 * @property string|null $nombre
 * @property int|null $nivel
 * @property int|null $vida
 * @property string|null $origen
 *
 * @property Clases[] $clases
 * @property Clases[] $clases0
 * @property Compran[] $comprans
 * @property Escriben[] $escribens
 * @property Realizan[] $realizans
 * @property Registran[] $registrans
 * @property TripulanteMonedero $tripulanteMonedero
 */
class Tripulantes extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'tripulantes';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['n_jugador', 'nombre', 'origen'], 'required'],
            [['nivel', 'vida'], 'integer'],
            [['origen'], 'string'],
            [['n_jugador'], 'string', 'max' => 20],
            [['nombre'], 'string', 'max' => 30],
            [['n_jugador'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'n_jugador' => 'N Jugador',
            'nombre' => 'Nombre',
            'nivel' => 'Nivel',
            'vida' => 'Vida',
            'origen' => 'Origen',
        ];
    }
    // Establezco un valor nicial para el nivel y la vida
    public function init()
    {
        parent::init();
        
        $this->nivel = 1;
        
        $this->vida = 100;
    }

    /**
     * Gets query for [[Clases]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getClases()
    {
        return $this->hasMany(Clases::class, ['n_jugador' => 'n_jugador']);
    }
    
    

    /**
     * Gets query for [[Clases0]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getClases0()
    {
        return $this->hasMany(Clases::class, ['n_jugador' => 'n_jugador']);
    }

    /**
     * Gets query for [[Comprans]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getComprans()
    {
        return $this->hasMany(Compran::class, ['n_jugador' => 'n_jugador']);
    }

    /**
     * Gets query for [[Escribens]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getEscribens()
    {
        return $this->hasMany(Escriben::class, ['n_jugador' => 'n_jugador']);
    }

    /**
     * Gets query for [[Realizans]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getRealizans()
    {
        return $this->hasMany(Realizan::class, ['n_jugador' => 'n_jugador']);
    }

    /**
     * Gets query for [[Registrans]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getRegistrans()
    {
        return $this->hasMany(Registran::class, ['n_jugador' => 'n_jugador']);
    }

    /**
     * Gets query for [[TripulanteMonedero]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getTripulanteMonedero()
    {
        return $this->hasOne(TripulanteMonedero::class, ['n_jugador' => 'n_jugador']);
    }
    
    
    //funcion que establece medida de salud de tripulantes
    public function getPorcentajeVida() {
        
        return ($this->vida / 30) * 100;
    }
}

controllers/ClasesController.php
<?php

namespace app\controllers;

use app\models\clases;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * ClasesController implements the CRUD actions for clases model.
 */
class ClasesController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all clases models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => clases::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'id' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single clases model.
     * @param int $id ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new clases model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new clases();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['tripulantes/index']);
                
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing clases model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $id ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing clases model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $id ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the clases model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $id ID
     * @return clases the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = clases::findOne(['id' => $id])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/TripulantesController.php
<?php

namespace app\controllers;

use Yii;
use app\models\tripulantes;
use app\models\Clases;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * TripulantesController implements the CRUD actions for tripulantes model.
 */
class TripulantesController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all tripulantes models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => tripulantes::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'n_jugador' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single tripulantes model.
     * @param string $n_jugador N Jugador
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($n_jugador)
    {
        return $this->render('view', [
            'model' => $this->findModel($n_jugador),
        ]);
    }

    /**
     * Creates a new tripulantes model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Tripulantes();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            //redirige al índice de tripulantes en lugar de la vista del tripulante
            return $this->redirect(['tripulantes/index']);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }


    /**
     * Updates an existing tripulantes model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param string $n_jugador N Jugador
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($n_jugador)
    {
        $model = $this->findModel($n_jugador);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['index', 'n_jugador' => $model->n_jugador]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }
    
    

    /**
     * Deletes an existing tripulantes model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param string $n_jugador N Jugador
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
    
    public function actionDelete($n_jugador)
    {
        $this->findModel($n_jugador)->delete();

        return $this->redirect(['index']);
    }
 */
    /**
     * Finds the tripulantes model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $n_jugador N Jugador
     * @return tripulantes the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($n_jugador)
    {
        if (($model = tripulantes::findOne(['n_jugador' => $n_jugador])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    
    public function actionDelete($n_jugador)
    {
        $transaction = Yii::$app->db->beginTransaction();
        try {
            $clases = Clases::findAll(['n_jugador' => $n_jugador]);
            foreach ($clases as $clase) {
                $clase->delete();
            }
            $this->findModel($n_jugador)->delete();
            $transaction->commit();
            return $this->redirect(['index']);
        } catch (\Exception $e) {
            $transaction->rollBack();
            throw $e;
        }
    }

    
    
    
    
    /**
     * Finds the tripulantes model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param string $n_jugador N Jugador
     * @return tripulantes the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     
    
    public function actionReducirVida() {
        if (Yii::$app->request->isAjax) {
            Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;
            $n_jugador = Yii::$app->request->post('n_jugador');
            $tripulante = Tripulantes::findOne(['n_jugador' => $n_jugador]);
            if ($tripulante && $tripulante->vida > 0) {
                $tripulante->vida--;
                if ($tripulante->save()) {
                    return ['success' => true, 'vida' => $tripulante->vida];
                }
            }
            return ['success' => false];
        }
        throw new BadRequestHttpException('Solicitud no permitida');
    }
    */
    
    
}

views/tripulantes/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;


/** @var yii\web\View $this */
/** @var app\models\tripulantes $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="tripulantes-form">

    <?php $form = ActiveForm::begin(); ?>

    <?php
    
    if ($model->isNewRecord) {
        echo $form->field($model, 'n_jugador')->textInput(['maxlength' => true]);
    } else {
        echo $form->field($model, 'n_jugador')->textInput(['readonly' => true]);
    }
    ?>

    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'origen')->textarea(['rows' => 6]) ?>

    




    <div class="form-group">
        <?= Html::submitButton('Guardar', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/tripulantes/create.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** 

$this->title = 'Create Tripulantes';
$this->params['breadcrumbs'][] = ['label' => 'Tripulantes', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;@var app\models\tripulantes $model */
$this->title = 'Crear Tripulantes';

?>
<div class="tripulantes-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
        
    ]) ?>
    
    

</div>

views/tripulantes/index.php
<?php

use app\models\clases;
use app\models\tripulantes;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use yii\grid\GridView;
use yii\helpers\ArrayHelper;


/** @var yii\web\View $this */
/** @var yii\data\ActiveDataProvider $dataProvider 

$this->title = 'Tripulantes';
$this->params['breadcrumbs'][] = $this->title;
*/
?>
<div class="tripulantes-index">

    <h1><?= Html::encode($this->title) ?></h1>

    
    
        

        
    <div class="container mt-5">
        <div class="tri-exp">
            <img src="<?= Yii::getAlias('@web') ?>/img/Slider-tri.jpg" alt="Imagen" width="60px"  class="tri-fondo">
            <h2 class="titulo-tripulantes">Tus tripulantes</h2>
        </div>
    </div>

    <style>
        .tri-exp {
            position: relative;
            border: 3px solid #AAD399;
            padding: 20px;
            color: #AAD399;
            box-shadow: 0 0 20px rgba(0, 255, 204, 0.5);
            text-shadow: 0 0 5px #AAD399;
            margin-bottom: 50px;
        }
        .tri-fondo {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            object-fit: cover;
            z-index: -1;
        }
        .titulo-tripulantes {
            color: #F5DF61;
            text-shadow: 0 0 10px #F5DF61;
            position: relative;
            z-index: 1;
        }
    </style>

    <p>
        <?= Html::a('Crear Tripulantes', ['create'], ['class' => 'btn btn-success']) ?>
    </p>

    <p>
        <?= Html::a('Asignar Clases', ['/clases/create'], ['class' => 'btn btn-success']) ?>
    </p>
    
    
    
    <style>
        
    .btn.btn-success {
        
        padding: 10px 20px; 
        font-size: 1em; 
        border: none;
        border-radius: 20px;
        background-color: #AAD399;
        color: black; 
        display: inline-block;
        cursor: pointer;
        box-shadow: 0 4px #759e64; 
        transition-duration: 0.4s;
    }

    .btn.btn-success:hover {
        background-color: #F5DF61;
        box-shadow: 0 4px #c9b649;
    }

    .btn.btn-success:active {
        background-color: #3e8e41; 
        box-shadow: 0 2px #666; 
        transform: translateY(2px); 
    }
    
    

    
    .grid-view th {
        background-color: transparent; 
        color: #aad399; 
        border: 2px solid #aad399; 
        box-shadow: 0 0 5px #aad399; 
        padding: 10px 20px; 
        font-size: 16px; 
        font-weight: bold; 
        border-radius: 15px; 
        box-shadow: 0 0 10px rgba(0, 255, 0, 0.5); 
        
    }

    .grid-view td {
        background-color: transparent; 
        border: 1px solid #aad399; 
        box-shadow: 0 0 5px #aad399; 
        padding: 10px 20px; 
        font-size: 16px; 
        font-weight: bold; 
        border-radius: 15px; 
        box-shadow: 0 0 10px rgba(0, 255, 0, 0.5); 
        
    }
    
 
    
    
    .tripulante-container {
        background-color: transparent;
        color: #aad399;
        border: 1px solid #aad399;
        box-shadow: 0 0 20px #aad399;
        padding: 10px 20px;
        font-size: 16px;
        font-weight: bold;
        border-radius: 15px;
        word-wrap: break-word; 
        margin-bottom: 20px; 

        transition: transform 0.5s ease, box-shadow 0.5s ease;
    }

    .tripulante-title {
        color: #f5df61; 
        font-size: 24px;
    }

    .barra-vida-container {
        background-color: #aad399; 
        border-radius: 5px;
        margin: 10px 0;
        box-shadow: 0 0 10px #aad399;
    }

    .barra-vida {
        background-color: #aad399; 
        height: 20px;
        border-radius: 5px;
        text-align: center;
        line-height: 20px;
        color: #aad399; 
    }

    .tripulante-actions a {
        color: #f5df61; 
        text-decoration: none;
        margin-right: 10px;
    }


    @keyframes pulsate {
            0% { box-shadow: 0 0 5px #30cfd0; }
            50% { box-shadow: 0 0 20px #30cfd0; }
            100% { box-shadow: 0 0 5px #30cfd0; }
        }

    .tripulante-container:hover {
            animation: pulsate 2s infinite;
        }    


</style>
    
    
    
    
    
    
    
    
    
    
    
    <?= \yii\widgets\ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => function ($model) {
        
        return "<div class='tripulante-container'>
                    <div class='tripulante-title'>{$model->nombre}</div>
                    <p><strong>Nombre de Jugador:</strong> {$model->n_jugador}</p>
                    <p><strong>Nivel:</strong> {$model->nivel}</p>
                    <p><strong>Origen:</strong> {$model->origen}</p>
                    <p><strong>Clases:</strong> " . implode(', ', ArrayHelper::map($model->clases, 'id', 'clase')) . "</p>
                    
                    <div class='tripulante-actions'>" .
                        
                        Html::a(Html::img('@web/img/ICONS/update.png'), ['update', 'n_jugador' => $model->n_jugador]) . " " .
                        Html::a(Html::img('@web/img/ICONS/borrar.png'), ['delete', 'n_jugador' => $model->n_jugador], [
                            'data' => [
                                'confirm' => '¿Estás seguro de que quieres eliminar este elemento?',
                                'method' => 'post',
                            ],
                        ]) . "
                    </div>
                </div>";
    },
    'layout' => "{summary}\n{items}\n{pager}",
]);
?>






    
    








</div>









<!-- BOTON MASCOTA -->
<?= Html::a('?', [''], ['class' => 'btn btn-primary btn-fijo', 'id' => 'boton-toggle']) ?>

<!-- CONTENEDOR MASCOTA -->
<div id="imagen-container" style="display: none; position: fixed; bottom: 100px; right: 30px; z-index: 101; background: transparent;">
    <img id="imagen-mascota" class="d-block w-1" src="<?= Yii::getAlias('@web')?>/img/ATH/ATH_TRI.png" style="width: 500px; height: auto;">
    <!-- BOTON SIGUIENTE -->
    <button id="boton-siguiente" class="btn btn-secondary">Siguiente</button>
</div>

<!-- JS MANEJAR MASCOTA -->
<script>
    document.getElementById('boton-toggle').addEventListener('click', function(event) {
        event.preventDefault();

        var boton = this;
        var imagenContainer = document.getElementById('imagen-container');

        if (imagenContainer.style.display === 'none') {
            imagenContainer.style.display = 'block';
            boton.innerHTML = 'X';
        } else {
            imagenContainer.style.display = 'none';
            boton.innerHTML = '?';
        }
    });

    // Array de imágenes
    var imagenes = [
        "<?= Yii::getAlias('@web')?>/img/ATH/ATH_TRI.png",

        "<?= Yii::getAlias('@web')?>/img/ATH/ATH_NIVELES.png"
    ];
    var indiceImagenActual = 0;

    // Función para cambiar la imagen
    function cambiarImagen() {
        indiceImagenActual = (indiceImagenActual + 1) % imagenes.length;
        document.getElementById('imagen-mascota').src = imagenes[indiceImagenActual];
    }

    // Evento para el botón Siguiente
    document.getElementById('boton-siguiente').addEventListener('click', cambiarImagen);
</script>

views/tripulantes/update.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\tripulantes $model */

$this->title = 'Update Tripulantes: ' . $model->n_jugador;

?>
<div class="tripulantes-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
        
    ]) ?>

</div>

views/tripulantes/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/** @var yii\web\View $this */
/** @var app\models\tripulantes $model */

$this->title = $model->n_jugador;
$this->params['breadcrumbs'][] = ['label' => 'Tripulantes', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="tripulantes-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'n_jugador' => $model->n_jugador], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'n_jugador' => $model->n_jugador], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'n_jugador',
            'nombre',
            'nivel',
            'origen:ntext',
            'raza',
        ],
    ]) ?>
    

</div>